<script lang="ts">
	import { formatDateShort } from '$lib';
	import type { Reply } from '$lib/types';
	import { MdOutlinedTextField } from '@material/web/all';
	import { onMount } from 'svelte';

	export let reply: Reply;
	export let showDate: boolean;
	export let first: boolean;

	let replying = false;
	let value = '';

	let textField: MdOutlinedTextField;

	onMount(() => {
		textField.addEventListener('change', () => {
			if (value != textField.value) {
				value = textField.value;
			}
		});
	});
</script>

{#if !first}
	<md-divider></md-divider>
{/if}
<md-list-item>
	<div slot="supporting-text" style:padding-top="0.5em">
		<div style:display="flex" style:justify-content="space-between" style:flex-wrap="wrap-reverse">
			<div style:display="flex" style:gap="1em">
				<div style:display="flex" style:align-items="center">
					<md-icon-button toggle>
						<md-icon>favorite</md-icon>
						<md-icon slot="selected" style:font-variation-settings="'FILL' 1">favorite</md-icon>
					</md-icon-button>
					{reply.liked}
				</div>
				<md-text-button
					on:click={() => {
						replying = true;
					}}
				>
					<md-icon slot="icon">reply</md-icon>
					Reply
				</md-text-button>
			</div>
			<div style:min-width="20ch" style:margin-inline-start="auto" style:text-align="end">
				by {reply.author.name}
				{#if showDate}
					at {formatDateShort(reply.date)}
				{/if}
			</div>
		</div>
	</div>
	{reply.content}
</md-list-item>
<md-list-item style:display={replying ? 'block' : 'none'}>
	<div style:display="flex" style:flex-direction="column" style:gap="1em">
		<md-outlined-text-field
			style:padding-top="0.5em"
			bind:this={textField}
			required
			type="textarea"
			label="Content"
			rows="3"
			{value}
			style:min-height="5em"
		>
		</md-outlined-text-field>
		<div style:display="flex" style:gap="1em" style:justify-content="end">
			<md-filled-button
				style:--md-filled-button-container-color="var(--md-sys-color-error)"
				on:click={() => {
					replying = false;
					value = '';
				}}>Cancel</md-filled-button
			>
			<md-filled-button>Send</md-filled-button>
		</div>
	</div>
</md-list-item>
<div style:padding-inline-start="8vw">
	{#each reply.replies as nestedReply}
		<svelte:self reply={nestedReply} showDate={true}></svelte:self>
	{/each}
</div>
